package com.bjtdba.order.dao;

import com.bjtdba.entity.order.StoreProductAttrValue;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * 商品属性值表(StoreProductAttrValue)表数据库访问层
 *
 * @author makejava
 * @since 2022-09-28 17:33:57
 */
@Repository
@Mapper
public interface StoreProductAttrValueDao {

    /**
     * 通过ID查询单条数据
     *
     * @param
     * @return 实例对象
     */
    StoreProductAttrValue queryById( );

    StoreProductAttrValue queryByunique(String unique);

    StoreProductAttrValue qeryByqueryByproduct(String productId);

    List<StoreProductAttrValue> queryAllByList(StoreProductAttrValue storeProductAttrValue);

    /**
     * 查询指定行数据
     *
     * @param storeProductAttrValue 查询条件
     * @param pageable         分页对象
     * @return 对象列表
     */
    List<StoreProductAttrValue> queryAllByLimit(StoreProductAttrValue storeProductAttrValue, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param storeProductAttrValue 查询条件
     * @return 总行数
     */
    long count(StoreProductAttrValue storeProductAttrValue);

    /**
     * 新增数据
     *
     * @param storeProductAttrValue 实例对象
     * @return 影响行数
     */
    int insert(StoreProductAttrValue storeProductAttrValue);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<StoreProductAttrValue> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<StoreProductAttrValue> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<StoreProductAttrValue> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<StoreProductAttrValue> entities);

    /**
     * 修改数据
     *
     * @param storeProductAttrValue 实例对象
     * @return 影响行数
     */
    int update(StoreProductAttrValue storeProductAttrValue);

    /**
     * 通过主键删除数据
     *
     * @param  主键
     * @return 影响行数
     */
    int deleteById( );

}

